﻿Option Strict On

Structure Circle
    Public ReadOnly Radius As Double
    Public ReadOnly Center As Point

    Public Sub New(ByVal Center As Point, ByVal Radius As Double)
        Me.Radius = Radius
        Me.Center = Center
    End Sub

    Public Sub New(ByVal A As Point, ByVal B As Point, ByVal C As Point)
        B = New Point(B.X - A.X, B.Y - A.Y)
        C = New Point(C.X - A.X, C.Y - A.Y)

        Dim D = 2 * (B.X * C.Y - B.Y * C.X)

        D = If(D = 0, 1, D)

        Dim X = (C.Y * (B.X ^ 2 + B.Y ^ 2) - B.Y * (C.X ^ 2 + C.Y ^ 2)) / D
        Dim Y = (B.X * (C.X ^ 2 + C.Y ^ 2) - C.X * (B.X ^ 2 + B.Y ^ 2)) / D

        Dim O = New Point(0, 0)

        Dim sa = Math.Sqrt(DistanceSq(O, B))
        Dim sb = Math.Sqrt(DistanceSq(O, C))
        Dim sc = Math.Sqrt(DistanceSq(B, C))

        Dim di = (2 * sa * sb * sc) / Math.Sqrt((sa + sb + sc) * _
                        (-sa + sb + sc) * (sa - sb + sc) * (sa + sb - sc))

        Me.Radius = di / 1.9
        Me.Center = New Point(CInt(A.X + X), CInt(A.Y + Y))
    End Sub

    Public Function Contains(ByVal p As Point) As Boolean
        Return DistanceSq(p, Center) <= Radius ^ 2
    End Function

    Public Sub Draw(ByVal g As Graphics)
        Using Pen = New Pen(Color.FromArgb(42, Color.Blue))
            Try
                Call g.DrawEllipse(Pen, New Rectangle(CInt(Center.X - Radius), _
                                                      CInt(Center.Y - Radius), _
                                                      CInt(2 * Radius), _
                                                      CInt(2 * Radius)))
            Catch ex As ArithmeticException
            End Try
        End Using
    End Sub
End Structure